<?php 
	ob_start();
	require_once('functions.php');
	session_start();

?>
<!DOCTYPE HTML>
<html>
<head>
<?php
		/* This 'IF' confirm all fields are full otherwise the 'ELSE' will run */
		if ($_SERVER['REQUEST_METHOD'] == 'POST' &&
			!empty($_POST['username']) &&
			!empty($_POST['password']) &&
			!empty($_POST['password_again']) &&
			!empty($_POST['first_name']) &&
			!empty($_POST['last_name']) &&
			!empty($_POST['email']) &&
			isset($_POST['submit'])
			){

				$conn = db_connect();


				// Storing POST's Keys variables in the $array_key
				$array_key = array_keys($_POST);

				/*Calling the field_length function to check whether user entered required amount of characters in the field or not */
				$username = field_length($conn, 
											ucfirst($array_key[0]), 
											$_POST['username']
										);

				if (preg_match ("/\\s/", $_POST['username']) == FALSE){
						
						if(is_null($username)){
							
							$username = $_POST['username'];
						}

				} else {

						$username .= " You can't use spaces in the username";
				}

				$first_name = field_length(	$conn, 
											ucwords(str_replace("_", " ", $array_key[3])), 
											$_POST['first_name']
										);

				$last_name = field_length(	$conn, 
											ucwords(str_replace("_", " ", $array_key[4])), 
											$_POST['last_name']
										);
			/* If email validation was unsuccessful 'NULL' will be assigned to $email */
				if (!filter_var($_POST['email'], 
					FILTER_VALIDATE_EMAIL)) {
					$email = "Email not valid, Please try again";
				} else { $email = $_POST['email']; }

				/* If password are not same 'NULL' will be assigned to $password */

				if ( strlen($_POST['password']) < 6 ||
						 strlen($_POST['password']) > 200
					){
						$password = " Password should be between 6 to 200 characters ";
				}

				if ( $_POST['password'] !== $_POST['password_again']){
					
					if(isset($password)){
					$password .= " and Passwords are not same! Please try again.";
					} else {$password = "Passwords are not same! Please try again.";}

				} else { $password = $_POST['password'];}
					


		/*Once we have all the values according to our need now it’s time to sanitize it and add it to the database */
		if ( $username == $_POST['username'] &&
			 is_null($first_name) &&
			 is_null($last_name) &&
			 $email == $_POST['email'] &&
			 $password == $_POST['password']
			){

				$username = safe_out($conn, $username);
				/* If NULL is not returned from the following query, an error will be shown to the user "username already exisit" 
				 */
				$username = query_user_check($conn, $username);

				$email = safe_out($conn, $email);
				
				/* If NULL is not returned from the following query, an error will be shown to the user "Email already exisit" 
				 */
				$email = query_email_check($conn, $email);

				if (is_null($username) && is_null($email)){
				
					/* Stripping out unwanted stuff */
					$user = safe_out($conn, $_POST['username']);
					$pass = safe_out($conn, $_POST['password']);
					$pass_hash = secure_password($password);
					$f_name = safe_out($conn, $_POST['first_name']);
					$l_name = safe_out($conn, $_POST['last_name']);
					$email = safe_out($conn, $_POST['email']);
					$vericode = substr(md5($user + microtime()), 1, 10);

					/* Inserting Record in the DB, If successfull a SESSION['username'] will be retruned back. */

					
					
					$result = query_insert_user($conn, $user, 
												$pass_hash, $f_name, 
												$l_name, 
												$email, $vericode);

					

					if(is_array($result)){

						$_SESSION['username'] = $result['username'];
						$_SESSION['email'] = $result['email'];
						$_SESSION['vericode'] = $result['vericode'];

						header("Location: verify.php");

			}
		}
	}
} 

		/* If any of the field is left blank in the FORM then the following Block will run. */


?>
	<title>Register An Account</title>
</head>	
<body>
<?php

	
	if (isset($status))
		{ echo $status . "<br />" ; }
	if ( isset($username) && $username != $_POST['username'])
		{echo $username . "<br />";} 
	if(isset($password) && $password != $_POST['password'])
		{echo $password . "<br />";}
	if(isset($first_name) && !is_null($first_name))
		{echo $first_name . "<br />";}
	if(isset($last_name) && !is_null($last_name))
		{echo $last_name . "<br />";}
	if(isset($email) && $email != $_POST['email'])
		{echo $email . "<br />";}




	
?>
<div id="RegWrap">
<h2>Register New Account</h2>
<div id="regform">

<form action="" method="post">

	<div class="row">
        <div class="label">
        	<label for="username"> Username*</label>
        </div> <!-- end .label -->

        <div class="input">
        	<input type="text" id="username" class="detail" name="username" value="<?php echo isset($_POST['username'])? $_POST['username'] : ''; ?>" />
        </div> <!-- end .input -->

        <div class="context">
        	e.g. John-Smith or JaneDoe
        </div>
        <!-- end .context -->
	</div> <!-- end .row -->

	<br />
	<div class="row">
        <div class="label">
        	<label for="password">Password*</label>
        </div> <!-- end .label -->

        <div class="input">
            <input type="password" id="password" class="detail" name="password">
        </div> <!-- end .input -->

        <div class="context">
        	This should be something safe that only you know about, feel free to use numbers, uppercase and lowercase letters
        </div> <!-- end .context -->
    </div> <!-- end .row -->

	<br />
	<div class="row">
		<div class="label">
			<label for="password_again">Confirm password*</label>
		</div> <!-- end .label -->

        <div class="input">
        	<input type="password" id="password_again" class="detail" name="password_again">
        </div> <!-- end .input -->

        <div class="context">
        	This should be something safe that only you know about, feel free to use numbers, uppercase and lowercase letters 
        </div> <!-- end .context -->
    </div> <!-- end .row -->
	
	<br />
	<div class="row">
		<div class="label">
			<label for="first_name">First name</label>
		</div> <!-- end .label -->

		<div class="input">
	        <input type="text" id="first_name" class="detail" name="first_name" value="<?php echo isset($_POST['first_name'])? $_POST['first_name'] : ''; ?>" />
        </div> <!-- end .input -->
    
        <div class="context">
        	e.g. John or Jane
        </div> <!-- end .context -->
    </div> <!-- end .row -->
	
	<br />
	<div class="row">
    	<div class="label">
    		<label for="last_name">Last name</label>
    	</div> <!-- end .label -->

    	<div class="input">
	        <input type="text" id="last_name" class="detail" name="last_name" value="<?php echo isset($_POST['last_name'])? $_POST['last_name'] : ''; ?>" />
        </div> <!-- end .input -->

        <div class="context">
        	e.g. Smith or Doe
        </div> <!-- end .context -->
    </div> <!-- end .row -->

    <br />
	<div class="row">
	    <div class="label">
	    	<label for="email">Your email address*</label>
	    </div> <!-- end .label -->

        <div class="input">
        	<input type="email" id="email" class="detail" name="email" value="<?php echo isset($_POST['email'])? $_POST['email'] : ''; ?>" />
        </div> <!-- end .input -->

        <div class="context">
        We will not share your email with anyone or spam you with messages either
        </div> <!-- end .context -->
     </div> <!-- end .row -->
	
	<div class="submit">
		<input type="submit" id="submit" name="submit" value="Register" />
	</div> <!-- end .submit-->
</form>
</div>
</div>

</body>
<?php 
        if (isset($conn)){

            mysqli_close($conn); 

          }

?>
</html>
<?php ob_end_flush(); ?>